#include <stdio.h>
#include <unistd.h>
#include <fcntl.h>
#include <termios.h>
//#include <wiringPi.h>
#include <string.h>
#include <time.h>
//#include <wiringPiI2C.h>
#include <errno.h>
#include <stdlib.h>
#include <ctype.h>
#include <bcm2835.h>

// LED Pin - wiringPi pin 0 is BCM_GPIO 17.

//#define	LED	1
#define OEN 0   // 7
#define PIN RPI_GPIO_P1_12
#define GAD 207 //globální adresa 0xFF

void send(char adr, char *text);
int datum();

char rx_buf[256];
char tx_buf[256];
char ht[32];

void help(){
	char hbuf[120];
	FILE *hlp;
if(NULL == (hlp= fopen("help1.txt", "rt"))){printf("Error: No help file!\n"); return;}

while(fgets(hbuf,100,hlp))	printf("%s",hbuf);



fclose(hlp);

	
}



int main(int argc, char *argv[])
{ 
char str[64]=""; 
//nt q2w;
int adr;
char text[64];

  //wiringPiSetup ();
  //pinMode (OEN, OUTPUT);
  if (!bcm2835_init())
	return 1;
  bcm2835_gpio_fsel(PIN, BCM2835_GPIO_FSEL_OUTP);
 
printf("PDK RS485 Controll\nh = help, e = exit\n\n");

while(1){ 
  
printf("adresa text: " );
gets(str);
if(str[0]=='e') break;
if(str[0]=='h'){ help(); continue;}

sscanf(str,"%d %[ -~]", &adr,  text);


//printf("chan = %d  fce=%s\n",adr, text);

 datum();

send(adr,  text); 
}

//gpio();
 bcm2835_close();
return 0;
}//main

void send(char adr, char *text) { 
	int len = 0; int rxl = 0; int fd = -1; int chsum = 0; int ps=0; int ch = 0;
	
 fd = open("/dev/ttyAMA0", O_WRONLY | O_NOCTTY | O_NDELAY);

if(fd ==-1){printf("Error\n");}
//printf("%d, %d\n",rxl, fd);

struct termios options, oldio;

tcgetattr(fd, &oldio);
bzero(&options, sizeof(options) );

options.c_cflag = B1200 | CS8 | CLOCAL |  CREAD;
options.c_iflag = IGNPAR;
options.c_oflag = 0;
options.c_lflag = 0;
tcflush(fd, TCIFLUSH);
tcsetattr(fd, TCSANOW, &options);
tx_buf[0]=0;

if(adr==0) adr=207; //GAD

if(text[0]=='L' && isdigit(text[1])) {
	int levl=0;
	levl = atoi(&text[1]);
	if(levl>90) levl=90;
	text[1] = (levl*15)/90  + 0x20;
	text[2] = 0;
	}



if(text[0]=='#')
{sprintf(tx_buf,"\x02%c%cY%s\x03", adr+0x30, 0x10, ht);
 printf("%d %s\n", adr, ht);}
else if(text[0]=='"')
{sprintf(tx_buf,"\x02%c%c%s\x03", adr+0x30, 0x0A, text+1);
printf("%d %s\n", adr, text+1);}
else
{sprintf(tx_buf,"\x02%c%c%s\x03", adr+0x30, 0x10, text);
printf("%d %s\n", adr, text);}

while(ch!=3){ch=tx_buf[ps]; ps++; chsum+=ch; };



tx_buf[ps]= (char)(chsum&0xFF);
ps++;
tx_buf[ps]= (char)(chsum>>8); 
ps++;
tx_buf[ps]= 0;
ps++;

  
//digitalWrite (OEN, HIGH) ; //enable TX
bcm2835_gpio_set(PIN);

int count = write(fd, tx_buf, ps);

if(count<0){printf("UART Error\n");}
//printf("%d %d\n",count, ps);

tcdrain(fd);
close(fd);

//digitalWrite (OEN, LOW); //dis. TX
bcm2835_gpio_clr(PIN);

//tcflush(fd, TCIFLUSH);
//tcsetattr(fd, TCSANOW, &options);


if(adr != GAD){
fd = open("/dev/ttyAMA0", O_RDONLY | O_NOCTTY | O_NDELAY);
len=0;
rx_buf[0]=0;
do{
	len++; 
	rxl = read(fd, rx_buf,1);
	
	usleep(1000); 
	}while(rxl<=0 && len< 600);

	if(rxl==1 && rx_buf[0]==6) printf("ACK\n");
	
	else printf("NACK\n");	
	//printf("%d %d\n",rxl, rx_buf[0]);
	
close(fd);
	}
//digitalWrite (LED, LOW) ;
tcsetattr(fd, TCSANOW, &oldio);
  }//send




int datum(){
	 static int oldt=0;	
     static time_t tim;
     static struct tm td;
     int wday=0;

	 tim=time(&tim);
	 td=*localtime(&tim);
	 if(oldt==td.tm_sec) return oldt;

	 oldt=td.tm_sec;
	 wday=td.tm_wday;
	 if(wday==0) wday=7; 
     sprintf(ht,"%02d:%02d:%02d %02d.%02d.%02d %1d", td.tm_hour,td.tm_min,td.tm_sec,td.tm_mday,td.tm_mon+1,td.tm_year-100, wday);   

     return oldt;
}



/*
void gpio(){
	printf ("Raspberry Pi blink\n") ;

 // wiringPiSetup () ;
 // pinMode (LED, OUTPUT) ;

  for (;;)
  {
  //  digitalWrite (LED, HIGH) ;	// On
    delay (500) ;		// mS
  //  digitalWrite (LED, LOW) ;	// Off
    delay (500) ;
  }
	}
*/	
 
 //  if ((q2w = wiringPiI2CSetup (0x77)) == -1)
 //   { fprintf (stderr, "q2w: Unable to initialise I2C: %s\n", strerror (errno)) ; return 1 ; }

//  printf("%x\n",q2w);
 // int reg = wiringPiI2CReadReg16(q2w, 0xAA) ;

//printf("%x\n",reg);
 // pinMode (LED, OUTPUT) ;	
	
