﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.IO.Ports;
using System.Threading;
using System.IO;
using System.Drawing.Printing;
using System.Windows;





namespace SerialRW1
{
    // public delegate void serialPort1_DataReceived(object sender, SerialDataReceivedEventArgs e);

    public partial class Form1 : Form
    {
        static int faze = 9;
        //   static int fazes = 9;
        //   static int tokno = 0;
        static SerialPort serp;
        static string comn = "";
        static Byte[] datas = null;
        static string opath = "";
        static string cpath = "C:\\Csharp";
        static int adr = 0x3000;
        bool cont = true;
        string ptext = "";
        bool rts = false;
        bool cts = false;
        bool dsr = false;
        bool dtr = false;
        bool cdt = false;
        bool comexist = true;     
        int rchr = 0;
        char nz = '\u0278';
        int ishex = 0;
        int hindex = 0;
        int pindex = 0;
        byte radr = 0;
        string datime = "";
        int ach = 0;
        int comm = 0;
        



        public Form1()
        {
            InitializeComponent();

            this.Icon = new System.Drawing.Icon("../../Ikona.ico");
            //  this.Icon = Properties.Resources.Ikona;

            this.progressBar1.Hide();
            text1 += "Zpráva k vyslání na ";
          //   text1 += Properties.Resources.t1;
            status1 = "Ready";

            richTextBox1.Text = "";

       //    Clock();
       //    richTextBox1.Text = datime;

            //  richTextBox1.LoadFile("C:/Csharp/RTF1.rtf");

            text3 = adr.ToString("X");

            try
            {
                string[] cports = SerialPort.GetPortNames();
                comn = cports[0];
                this.comboBox1.Items.AddRange(cports); //zjištěné porty do comboboxu
                InitCOM();
            }
            catch (IndexOutOfRangeException ei)
            {
                MessageBox.Show(
                     "Sériový port nenalezen. \r\n" + ei.GetType().Name);
                comn = "";
                comexist = false;
            }
            text1 += comn;
            button5.Enabled = false;
            button6.Enabled = false;


        } //Form1


        public void Clock()
        {

       //   DateTime dtim = new DateTime(2014,7,21); 
            DateTime dtim = DateTime.Now;
           
            int dw = dtim.DayOfWeek.GetHashCode();
            if (dw == 0) dw = 7;
            datime = dtim.ToString("HH:mm:ss dd.MM.yy ") +dw.ToString();
            

       }


        public void InitCOM()
        {
            serp = new SerialPort();
            serp.PortName = comn;
            serp.ReadTimeout = -1;
            serp.BaudRate = 1200;
            serp.Parity = Parity.Even;
            serp.ParityReplace =  0x3F; 
            serp.DataBits = 8;
            serp.StopBits = StopBits.Two;
            serp.Handshake = 0;
            serp.DataReceived += new System.IO.Ports.SerialDataReceivedEventHandler(this.serialPort1_DataReceived);
            serp.PinChanged += new System.IO.Ports.SerialPinChangedEventHandler(this.serialPort1_Pin);
            serp.WriteTimeout = -1;

            serp.Open();
            comboBox1.SelectedIndex = 0; //na první nalezený port 
            comboBox2.SelectedIndex = 3; // 1200
            comboBox3.SelectedIndex = 0; // Even = 2
            comboBox4.SelectedIndex = 0; // Two
            comboBox5.SelectedIndex = 0; // None handshake
            comboBox6.SelectedIndex = 3; // 8 
            comboBox7.SelectedIndex = 0; // Protocol
            comboBox8.SelectedIndex = 2; // kanál

        }


        private void tiky_Tick(object sender, System.EventArgs e)
        {
            tiky.Enabled = false;
            progressBar1.Value = 0; //progressBar1.Refresh();
            progressBar1.Hide();
            //status1 += " Ready"; 
        }


        private void TeLen()
        {
            int len;
            if (datas == null) { len = 0; text4 = ""; return; }
            else len = datas.Length;
            if (len > 0)
            {
                text4 = (adr + len - 1).ToString("X");
                status2 = "Délka " + len + " bytů";
            }
            else
            {
                text4 = ""; // (adr).ToString("X");
                status2 = "Délka " + len + " bytů - chyba";
            }
            //  richTextBox1.Text = strRTF; richTextBox1.Refresh();
        }

        private void WriteC()
        {
         //  if (sendtime) { Clock(); text2 = datime; datas = System.Text.Encoding.Default.GetBytes(datime);   }
        
     //   if (!comexist) return;
            int numz = 1;
            int eadr = 0;
            int sadr = adr;
            int chsum = 0;
            char adrs='0', par;
            char baud;
           
            
            cont = true;
            if (pindex==4) { Clock(); text1 = datime;  datas = System.Text.Encoding.Default.GetBytes(datime);  }
            if (pindex == 5) //commands
            {                               
                    string str = "", ostr = "", num = "";
                    char xch;
                    int x = 0;

                    var txt = text1.Split('\r', '\n', '\0');
                    int xlen = txt[0].Length;
                    while (x < xlen)
                    {
                        xch = txt[0][x]; x++;
                        if (xch == ' ' || xch == ',') continue;
                        str += xch;
                    }

                    xlen = str.Length; x = 0;
                    while (x < xlen)
                    {
                        xch = str[x]; x++; ostr += xch;
                        if (xch == 'L' && x < xlen)
                        {                         
                           while (x < xlen)
                            {
                                xch = str[x];
                                if (xch <= '9' && xch >= '0') { num += xch; x++; }
                                else { break; }
                            }
                            if (num.Length > 0)
                            {
                                int levl = Convert.ToInt16(num);
                                if (levl > 90) levl = 90;
                                int lkod = (levl * 47) / 90 + 0x20;
                                ostr += Convert.ToChar(lkod);
                            }
                            
                        } //if xch == L

                        else if (xch == 'I' && x < xlen)
                        {
                            adrs = str[x]; x++;
                            par = str[x]; x++;
                            num = "";
                            while (x < xlen)
                            {
                                xch = str[x];
                                if (xch <= '9' && xch >= '0') { num += xch; x++; }
                                else { break; }
                            }

                            switch (par)
                            {
                                case 'N': par = '0';
                                    break;
                                case 'M': par = '1';
                                    break;
                                case 'S': par = '2';
                                    break;
                                case 'O': par = '3';
                                    break;
                                case 'E': par = '4';
                                    break;
                                default: par = '0';
                                    break;
                            }

                            switch (Convert.ToInt32(num))
                            {
                                case 12: baud = '0';
                                    break;
                                case 24: baud = '1';
                                    break;
                                case 48: baud = '2';
                                    break;
                                case 96: baud = '3';
                                    break;
                                case 19:
                                case 192:
                                    baud = '4';
                                    break;
                                default: baud = '0';
                                    break;
                            }
                            ostr +=  "" + adrs + par + baud;
                        }
                    }


                    //   text1 += ostr;
                   //   text2 += "  "; text2 += num;
                    datas = System.Text.Encoding.Default.GetBytes(ostr);
                    //   return;
                
            }
            text2 = "";
            if (datas == null) { status1 = "Není načtený soubor"; return; }
            else status1 = opath == "" ? "Data..." : opath;
            status2 = ""; statusStrip1.Refresh();
            serp.WriteTimeout = 100000;
            Byte[] hlava = new Byte[72];
            for (int i = 0; i < 64; i++) hlava[i] = 0;
            int len = datas.Length;
            eadr = adr + len - 1;
            text4 = eadr.ToString("X"); textBox4.Refresh();
            hlava[64] = 1;
            hlava[65] = (byte)numz;
            hlava[66] = (byte)adr;
            hlava[67] = (byte)(adr >> 8);
            hlava[68] = (byte)eadr;
            hlava[69] = (byte)(eadr >> 8);
            hlava[70] = (byte)sadr;
            hlava[71] = (byte)(sadr >> 8);
            progressBar1.Value = 0;
            progressBar1.Step = 1;
            progressBar1.Show();
            //  progressBar1.Refresh();
            if (faze == 0)
            {
                progressBar1.Maximum = len + 72;
                try
                {
                    for (int i = 0; i < 72; i++)
                    {
                        Application.DoEvents(); if (cont == false) break; serp.Write(hlava, i, 1);
                        progressBar1.PerformStep(); while (serp.BytesToWrite > 0) { ;};
                    }

                    status2 = "Vysláno " + len.ToString() + " bytů"; statusStrip1.Refresh();
                }
                catch (TimeoutException)
                {
                    text2 = "TIMEOUT !";  //textBox2.Refresh();                   
                }
            }
            if (faze == 9) progressBar1.Maximum = len;
            {
               // if (radr == 0) radr = 207; 
                if (pindex == 3 ) { hlava[64] = 2; hlava[65] = (byte)(radr==0 ? 255 : radr + 0x30) ; hlava[66] = 0x0A; hlava[68] = 0x03;  serp.RtsEnable = true; }

                if (pindex == 4) { hlava[64] = 2; hlava[65] = (byte)(radr == 0 ? 255 : radr + 0x30); hlava[66] = 0x10; hlava[67] = (byte)'Y';  hlava[68] = 0x03; serp.RtsEnable = true; }

                if (pindex == 5) { hlava[64] = 2; hlava[65] = (byte)(radr == 0 ? 255 : radr + 0x30); hlava[66] = 0x10;  hlava[68] = 0x03; serp.RtsEnable = true; }

            //   hlava[71] = 0x55;


                chsum = 2; chsum += hlava[65]; chsum += hlava[66]; chsum += 3;

                try
                {  if(pindex>2)serp.Write(hlava, 0, 4); //první nulové znaky - ignorují se
                   if(pindex==3) serp.Write(hlava, 64, 3);
                   if (pindex == 4) { serp.Write(hlava, 64, 4); chsum += hlava[67]; }
                   if (pindex == 5) serp.Write(hlava, 64, 3);
                   
                    for (int i = 0; i < len; i++)
                    {
                        if (cont == false) break; Application.DoEvents(); serp.Write(datas, i, 1); chsum += datas[i];
                        progressBar1.PerformStep(); while (serp.BytesToWrite > 0) { ;};
                        
                    } 
                    
                    status2 = "Vysláno " + len.ToString() + " bytů"; statusStrip1.Refresh();

                    if (pindex == 3 || pindex == 4 || pindex == 5)
                    {
                        hlava[69] = (byte)(chsum & 0xFF);
                   //     hlava[69] = 0x55;
                        hlava[70] = (byte)((chsum >> 8) & 0xFF);
                        hlava[71] = 0; //byte navíc
                          //  serp.Write(hlava, 68, 1); //vyšle 0x3
                            serp.Write(hlava, 68, 1); //vyšle 0x3 a 2 byty check sum       a znak 0x0
                            serp.Write(hlava, 69, 1);
                            serp.Write(hlava, 70, 1); 
                        }
                    
                   
                    
                }
                catch (TimeoutException)
                {
                    text2 = "TIMEOUT !";  //textBox2.Refresh();                   
                }

            }

            tiky.Enabled = true;
            status1 = "Ready";
            if (pindex == 3 || pindex == 4 || pindex == 5)
            {
                serp.ReadTimeout = 3000;
                try
                {
                while (serp.ReadByte() != 0x03) { ;};
                while (serp.ReadByte() != hlava[69]) { ;}; //)
                while (serp.ReadByte() != hlava[70]) {;};  //) { ;};
           //    while (serp.ReadByte() != 0) ;
            
                    
                   
                  //  text2 = "OK"; 
                    serp.RtsEnable = false;
                //  serp.DiscardInBuffer();
                  }
                catch (TimeoutException)
                {
                    text2 = "TIMEOUT !"; // richTextBox1.Refresh(); return;
                }   
                    if (radr != 0)
                    {
                        serp.ReadTimeout = 3000;
                        try
                        {
                           // while (serp.BytesToRead == 0) { int x = 1; x++; };

                        do { ach = serp.ReadByte(); } while (ach != 6  && ach != 0x15); 

                       //     while (serp.ReadByte() != 0x06) { ;}; text2 = "ACK";
                        if (ach == 6) text2 = "ACK";
                          if (ach == 0x15) text2 = "NAK";
                        }
                        catch (TimeoutException)
                        {
                            text2 = "TIMEOUT !";// return;
                        }
                           // if (serp.ReadByte() == 0x06)
                           //     text2 = "ACK";
                       // text2 += chsum.ToString();
                    }
               
            }
              //  serp.Parity = Parity.Even;
         //   for (int x = 0; x < 16; x++) { if (text1[x] == 'M')ReadC(1); }
            if (text1.Contains("M1") || text1.Contains("M2") || text1.Contains("M3")) ReadC(1);
            else if (text1.Contains("M0")) ReadC(3);
        }

        public void serialPort1_DataReceived(object sender, SerialDataReceivedEventArgs e)
        {
            rchr = 1;
        }


        public void serialPort1_Pin(object sender, SerialPinChangedEventArgs e)
        {
            CheckForIllegalCrossThreadCalls = false;

            if (serp.CtsHolding)
            {
                cts = true; label3.BackColor = System.Drawing.Color.LightGreen;
                //  label3.Text = "CTS ON";
            }
            else
            {
                cts = false; label3.BackColor = System.Drawing.Color.Empty;
                //  label3.Text = "CTS";
            }

            if (serp.DsrHolding) { dsr = true; label4.BackColor = System.Drawing.Color.LightGreen; }
            else { dsr = false; label4.BackColor = System.Drawing.Color.Empty; }



            if (serp.CDHolding) { cdt = true; label5.BackColor = System.Drawing.Color.LightGreen; }
            else { cdt = false; label5.BackColor = System.Drawing.Color.Empty; }

        }




        public void ReadC(int nch)
        {
            if (!comexist) return;
            string path = "c:/Csharp/comrec.txt";
            string mes1 = "";
            int numz = 0;
            int lad = 10, had = 0, lea = 0, hea = 0, lst = 0, hst = 0;
            int ix = 0;
            int bt = 0;
            int ch = 0;
            int nb = 0;
            List<byte> binar = new List<byte>(0);
            datas = null;
            cont = true;

            status2 = ""; //statusStrip1.Refresh();                                   
            text2 = "Čekám ...";
            Application.DoEvents();
            serp.ReadTimeout = 10000;
            progressBar1.Value = 0;
            progressBar1.Minimum = 0;
            progressBar1.Maximum = 1000;
            progressBar1.Step = 1;
            serp.DiscardInBuffer();
            rchr = 0;

            while (cont)
            {
                try
                {
                    Application.DoEvents();

                    while (rchr == 0) { Application.DoEvents(); if (cont == false) { text2 = ""; goto lab1; } }
                    ch = serp.ReadByte();

                    progressBar1.PerformStep();
                    Application.DoEvents();
                    nb++;
                    serp.ReadTimeout = 500;
                }
                    
                catch (TimeoutException)
                {
                    if (faze == 9) mes1 = "";
                    if (bt == 0) mes1 = "      TIMEOUT !";
                    text2 = mes1; //textBox2.Refresh();

                    goto lab1;
                } // 

                if (ix == 0) { text2 = " Data.....\r\n"; ix++; progressBar1.Show(); status1 = "Příjem"; }  //statusStrip1.Refresh(); }
                switch (faze)
                {
                    case 0: if (ch == 1) faze = 1;

                        break;
                    case 1: numz = ch; faze = 2; break; //číslo záznamu
                    case 2: faze = 3; lad = ch; break;  //počátečná adresa 
                    case 3: faze = 4; had = ch; break;
                    case 4: faze = 5; lea = ch; break;  //koncová adresa
                    case 5: faze = 6; hea = ch; break;
                    case 6: faze = 7; lst = ch; break;  //adresa vstupu do pgm, nebo 0
                    case 7: faze = 8; hst = ch;         //vlastní záznam

                        lad += (had << 8);
                        lea += (hea << 8);
                        if (lea <= lad)
                        {
                            MessageBox.Show("Chyba v adrese"); if (faze == 8) faze = 0;
                            ix = 0;
                            status1 = "";
                            text2 = "";
                            serp.ReadTimeout = -1;
                            progressBar1.Value = 0;
                            progressBar1.Hide();
                            return;
                        }
                        progressBar1.Maximum = (lea - lad + nb);
                        text2 += "#" + numz.ToString("X") + "  " + lad.ToString("X") + " - " + lea.ToString("X") + "\r\n";
                        richTextBox1.Refresh();       //výpis hlavičky, je-li zatržítko - záznam s hlavičkou  
                        break;
                    default:
                        binar.Add((byte)ch); bt++;
                        break;  // do pole 
                }//switch
                if ((faze == 8 && (lea - lad + 1) == bt)) { serp.ReadTimeout = -1; break; }    //dosažen načtený počet bytů podle hlavičky        
            }//while

            if (cont == false) bt = 0;
        lab1:
            if (bt > 0)
            {
                datas = binar.ToArray();

                int ni = Math.Min(20000, datas.Length); //max 200 znaků             
                if (nch > 0)
                {
                    if (nch == 3)
                    {
                        text1 += "\r\n";
                        if ((datas[0] & 8) == 8) text1 += "S "; else text1 += "s ";
                        if ((datas[0] & 4) == 4) text1 += "L "; else text1 += "l ";
                        if ((datas[0] & 2) == 2) text1 += "F "; else text1 += "f ";                    
                        if ((datas[0] & 1) == 1) text1 += "T "; else text1 += "t ";

                        if ((datas[1] & 8) == 8) text1 += "C "; else text1 += "c ";
                        if ((datas[1] & 4) == 4) text1 += "D "; else text1 += "d ";                            
                        if ((datas[1] & 2) == 2) text1 += "A  "; else text1 += "a  ";

                     //  text1 += (((datas[2] & 0x1F) * 8 * 100) / 256).ToString(); text1 += "%";
                        text1 += (((datas[2] & 0x1F) * 90 + 20) / 47).ToString(); text1 += "%";
                    }
                    else text1 += "\r\n" + System.Text.Encoding.Default.GetString(datas, 0, ni).Replace('\0', nz);

                }
                else
                    text1 = System.Text.Encoding.Default.GetString(datas, 0, ni).Replace('\0', nz);

                FileStream fs = File.Open(path, FileMode.Create, FileAccess.Write, FileShare.None);  //zápis do souboru                     
                fs.Write(datas, 0, bt);
                fs.Close();

                text2 += "END"; //textBox2.Refresh();
                if (!IsText(datas)) text2 += "\r\nSoubor obsahuje nulové znaky!";
                status2 = "Přijato " + datas.Length.ToString() + " bytů";
                status1 = "Data z " + comn; //statusStrip1.Refresh();
            }
            if (faze == 8) faze = 0;
            ix = 0; rchr = 0;
            serp.ReadTimeout = -1;

            tiky.Enabled = true;

        }//ReadC





        private void toolStripMenuItem1_Click(object sender, EventArgs e) { }

        private void openToolStripMenuItem_Click(object sender, EventArgs e)
        {
            OpenFileDialog openFileDialog1 = new OpenFileDialog();
            openFileDialog1.InitialDirectory = cpath;
            openFileDialog1.Filter = "txt files (*.txt)|*.txt|All files (*.*)|*.*";
            openFileDialog1.FilterIndex = 2;
            openFileDialog1.RestoreDirectory = true;
            text2 = "";
            text1 = "";

            if (openFileDialog1.ShowDialog() == DialogResult.OK)
            {
                try
                {
                    opath = string.Join("\n", openFileDialog1.FileNames);
                    status1 = opath;
                    datas = System.IO.File.ReadAllBytes(opath);
                    TeLen();
                    int ni = Math.Min(20000, datas.Length); //max 20000 znaků                               
                    if (!IsText(datas)) text2 += " Soubor obsahuje nulové znaky!";
                    text1 = System.Text.Encoding.Default.GetString(datas, 0, ni).Replace('\0', nz);
                    if (ishex==1) text1 = HexStr(datas);
                }
                catch (Exception ex)
                {
                    MessageBox.Show("Error: Soubor nelze přečíst: " + ex.Message);
                }
            }
        }//



        private void saveToolStripMenuItem_Click(object sender, EventArgs e)
        {
            bool fe = false;

            if (datas == null) { status1 = "Není načtený soubor"; status2 = ""; MessageBox.Show("Nejsou data!"); return; }

            if (opath != "")
            {
                FileInfo fInfo = new FileInfo(opath);
                if (fInfo.Exists) fe = true;
            };
            if (fe)
            {
                FileStream fs = File.Open(opath, FileMode.Create, FileAccess.Write, FileShare.None);  //zápis do souboru   
                fs.Write(datas, 0, datas.Length);
                fs.Close();
                status2 = "Uloženo " + datas.Length.ToString() + " bytů";
            }
            else
            {
                SaveFileDialog saveFileDialog1 = new SaveFileDialog();
                saveFileDialog1.InitialDirectory = cpath;
                saveFileDialog1.Filter = "txt files (*.txt)|*.txt|All files (*.*)|*.*";
                saveFileDialog1.FilterIndex = 2;
                saveFileDialog1.RestoreDirectory = true;

                if (saveFileDialog1.ShowDialog() == DialogResult.OK)
                {
                    string path = saveFileDialog1.FileName;
                    FileStream fs = File.Open(path, FileMode.Create, FileAccess.Write, FileShare.None);  //zápis do souboru   
                    fs.Write(datas, 0, datas.Length);
                    fs.Close();
                    status2 = "Uloženo " + datas.Length.ToString() + " bytů";
                    opath = status1 = path;
                }
            }
        }//

        private void saveAsToolStripMenuItem_Click(object sender, EventArgs e)
        {
            if (datas == null) { status1 = "Není načtený soubor"; status2 = ""; MessageBox.Show("Nejsou data!"); return; }
            SaveFileDialog saveFileDialog1 = new SaveFileDialog();
            saveFileDialog1.InitialDirectory = cpath;
            saveFileDialog1.Filter = "txt files (*.txt)|*.txt|All files (*.*)|*.*";
            saveFileDialog1.FilterIndex = 2;
            saveFileDialog1.RestoreDirectory = true;

            if (saveFileDialog1.ShowDialog() == DialogResult.OK)
            {
                string path = saveFileDialog1.FileName;
                FileStream fs = File.Open(path, FileMode.Create, FileAccess.Write, FileShare.None);  //zápis do souboru   
                fs.Write(datas, 0, datas.Length);
                fs.Close();
                status2 = "Uloženo " + datas.Length.ToString() + " bytů";
                opath = status1 = path;
            }
        }//


        private void directoryToolStripMenuItem_Click(object sender, EventArgs e)
        {
            FolderBrowserDialog folderDialog1 = new FolderBrowserDialog();
            folderDialog1.SelectedPath = cpath;
            if (folderDialog1.ShowDialog() == DialogResult.OK)
            {
                cpath = folderDialog1.SelectedPath;
            }
        }//



        private void toolStripStatusLabel1_Click(object sender, EventArgs e) { }

        private void toolStripStatusLabel2_Click(object sender, EventArgs e) { }

        private void statusStrip1_ItemClicked(object sender, ToolStripItemClickedEventArgs e) { }

        private void progressBar1_Click(object sender, EventArgs e) { }

        private void exitToolStripMenuItem_Click(object sender, EventArgs e)
        {
            Close();
        }

        static string pfont = "Arial";

        private void printToolStripMenuItem_Click(object sender, EventArgs e)
        {
            if (datas != null)
            {
                if (IsText(datas))
                { pfont = "Arial"; ptext = System.Text.Encoding.Default.GetString(datas, 0, datas.Length); }
                else { pfont = "Courier New"; ptext = HexStr(datas); }

                System.Drawing.Printing.PrintDocument pDoc = new System.Drawing.Printing.PrintDocument();
                PrintDialog pDial = new PrintDialog();
                pDial.AllowSomePages = true;
                if (pDial.ShowDialog() == DialogResult.OK)
                {
                    pDoc.PrintPage += new PrintPageEventHandler(this.docPrintPage);
                    pDoc.DocumentName = opath;
                    pDoc.Print();
                }
            }
            else MessageBox.Show("Není co tisknout!");
        }//

        private void docPrintPage(object sender, System.Drawing.Printing.PrintPageEventArgs e)
        {
            System.Drawing.Font printFont = new System.Drawing.Font(pfont, 10, System.Drawing.FontStyle.Regular);
            e.Graphics.DrawString(ptext, printFont, System.Drawing.Brushes.Black, 75, 75);
        }


        //----------------------------------------------------------------------------------------------------------------------

        private void comboBox1_SelectedIndexChanged(object sender, EventArgs e)
        {
          
            comn = (string)comboBox1.SelectedItem;
            comexist = true;
            try
            {
                if (serp.IsOpen) serp.Close();
                serp.PortName = comn;
                serp.Open();
            }
            catch (IOException ei)
            {
                comexist = false;
                MessageBox.Show(
                     "Sériový port " + comn + " neexistuje. \r\nZkus jiný.\r\n" + ei.GetType().Name);
            }
        }//comboBox


        private void comboBox2_SelectedIndexChanged(object sender, EventArgs e)
        {
            if (!comexist) return;
            serp.BaudRate = Convert.ToInt32(comboBox2.SelectedItem);
        }

        private void comboBox3_SelectedIndexChanged(object sender, EventArgs e)
        {
            if (!comexist) return;
            string parity = Convert.ToString(comboBox3.SelectedItem);
            serp.Parity = (Parity)Enum.Parse(typeof(Parity), parity, true);
        }

        string[] sbits = new string[] { "One", "Two", "OnePointFive" };

        private void comboBox4_SelectedIndexChanged(object sender, EventArgs e)    //stopbits
        {
            if (!comexist) return;
            int seli = comboBox4.SelectedIndex;
            if (serp.DataBits == 5 && seli == 1) seli = 2;   // 5 dbits může mít 1 nebo 1,5 stop bitu
            if (seli == 2 && serp.DataBits > 5)
            {
                serp.StopBits = (StopBits)Enum.Parse(typeof(StopBits), sbits[0], true);
                serp.DataBits = 5; comboBox6.SelectedIndex = 0;
            }
            else
            {
                serp.StopBits = (StopBits)Enum.Parse(typeof(StopBits), sbits[seli], true);
                comboBox4.SelectedIndex = seli;
            }
            //  text2 = serp.StopBits.ToString() + "  " + serp.DataBits;
        }



        private void comboBox6_SelectedIndexChanged(object sender, EventArgs e)   //databits
        {
            if (!comexist) return;
            int dbits = Convert.ToInt32(comboBox6.SelectedItem);
            if (dbits == 5)
            {
                comboBox4.SelectedIndex = 2;
                serp.StopBits = (StopBits)Enum.Parse(typeof(StopBits), sbits[2], true);
            }
            if (dbits > 5 && serp.StopBits.ToString() == sbits[2])
            {
                comboBox4.SelectedIndex = 0;
                serp.StopBits = (StopBits)Enum.Parse(typeof(StopBits), sbits[0], true);
            }
            serp.DataBits = dbits;
            //   text2 = serp.StopBits.ToString() + "  " + serp.DataBits;

        }

        private void comboBox5_SelectedIndexChanged(object sender, EventArgs e)
        {
            if (!comexist) return;
            hindex = comboBox5.SelectedIndex;
            if (hindex < 4)
            {
                string[] hands = new string[] { "None", "XOnXOff", "RequestToSend", "RequestToSendXOnXoff" };
                serp.Handshake = (Handshake)Enum.Parse(typeof(Handshake), hands[hindex], true);
            }
            else
            {
                serp.Handshake = (Handshake)Enum.Parse(typeof(Handshake), "None", true);
            }
        }


        private void comboBox7_SelectedIndexChanged(object sender, EventArgs e)   //databits
        {
         //   if (!comexist) return;
            pindex = comboBox7.SelectedIndex;
            if (pindex != 1) faze = 9;
            if (pindex == 1) faze = 0;
          //  if (pindex == 4) { sendtime = true; } else sendtime = false;
            if (pindex == 5) text1 = "";  //smaže text
        }


        private void comboBox8_SelectedIndexChanged(object sender, EventArgs e)
        {
            if (!comexist) return;
            radr = (byte)comboBox8.SelectedIndex;
           
        }

        private void comboBox9_SelectedIndexChanged(object sender, EventArgs e)
        {
        
            if (pindex == 5)
            {
                comm = (byte)comboBox9.SelectedIndex;
                switch (comm)
                {
                    case 0: text1 += "S ";
                        break;
                    case 1: text1 += "s ";
                        break;
                    case 2: text1 += "L8 ";
                        break;
                    case 3: text1 += "l ";
                        break;
                    case 4: text1 += "F ";
                        break;
                    case 5: text1 += "f ";
                        break;
                    case 6: text1 += "T ";
                        break;
                    case 7: text1 += "t ";
                        break;                    
                    case 8: text1 += "C ";
                        break;
                    case 9: text1 += "c ";
                        break;
                    case 10: text1 += "D ";
                        break;
                    case 11: text1 += "d ";
                        break;
                    case 12: text1 += "A00:00 ";
                        break;
                    case 13: text1 += "a ";
                        break;
                    case 14: text1 += "R ";
                        break;
                    case 15: text1 += "I 1 N 12 ";                     
                        break;
                    case 16: text1 += "E ";
                        break;
                    case 17: text1 += "M1 "; 
                        break;
                    case 18: text1 += "B ";
                        break;
                    
                    
                   
                   
                }
            }
            datas = System.Text.Encoding.Default.GetBytes(text1.Replace(nz, '\0'));
        }


        private void textBox1_TextChanged(object sender, EventArgs e)
        {
            if (ishex==0 && text1 != "" && textBox1.Focused)
            {
                datas = System.Text.Encoding.Default.GetBytes(text1.Replace(nz, '\0'));
            };
            if (ishex==1 && text1 != "" && textBox1.Focused) { button6.Enabled = true; button5.Enabled = true; }

            TeLen();
        }

        private void textBox2_TextChanged(object sender, EventArgs e) { }


        private void textBox3_TextChanged(object sender, EventArgs e)  //adresa hex
        {
            adr = Convert.ToInt32(textBox3.Text, 16);
            text3 = adr.ToString("X");
            if (datas != null)
            {
                TeLen();
            }
        }

        private void textBox4_TextChanged(object sender, EventArgs e) { }


        private string Hex(int check, TextBox textBox)
        {
            int adrs = adr;
            string tx = "";

            this.Cursor = Cursors.WaitCursor;

            if (datas == null)
            {
                if (textBox.Text != "")
                {
                    datas = System.Text.Encoding.Default.GetBytes(textBox.Text); status1 = "Text z boxu"; TeLen();
                }
                else { datas = null; status1 = "Žádná data!"; this.Cursor = Cursors.Arrow; return tx; }
            };

            if (datas != null)
            {
                if (check>0)
                {
                    textBox.Font = new System.Drawing.Font("Courier New", 10F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((byte)(238)));
                    textBox.ForeColor = System.Drawing.Color.Green;
                    tx = HexStr(datas);
                }
                else
                {
                    if (datas != null)
                    {
                        if (IsText(datas))
                        {
                            tx = System.Text.Encoding.Default.GetString(datas, 0, datas.Length);
                            status1 = "Ready";
                        }
                        else
                        {
                            text2 = "Soubor obsahuje nulové znaky!";
                            tx = System.Text.Encoding.Default.GetString(datas, 0, datas.Length).Replace('\0', nz);
                        }
                    }
                    textBox.Font = new System.Drawing.Font("Microsoft Sans Serif", 11F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(238)));
                    textBox.ForeColor = System.Drawing.SystemColors.WindowText;
                }
            }
            this.Cursor = Cursors.Arrow;
            return tx;
        }//

        public bool IsText(Byte[] data)
        {

            bool ei = true;
            if (data != null)
            {
                foreach (byte bt in datas) if (bt == 0) { ei = false; break; }
            }
            return ei;
        }//

        public string HexStr(Byte[] data)
        {
            bool cykl = true;
            string str = "";
            int adrs = adr;
            int j = 0;
            int len = 0;
            char ch;
            if (data != null)
            {
                len = data.Length;
                do
                {
                    str += String.Format("{0,4:X4}: ", adrs);

                    if (ishex == 1) { for (int i = 0; i < Math.Min(len, 16); i++) { str += String.Format("{0,2:X2} ", data[j]); j++; if (j == len) { cykl = false; break; } } }
                    if (ishex == 2) { for (int i = 0; i < Math.Min(len, 16); i++) { if ((ch = (char)data[j]) == '\0')ch = nz;  str += String.Format(" {0} ", ch); j++; if (j == len) { cykl = false; break; } } }
                    str += "\r\n"; adrs += 16;

                } while (cykl);
            }
            return str; //textBox1.Reresh();
        }//

        public Byte[] BinStr(string str)
        {
            Byte[] data = null;
            List<byte> binar = new List<byte>(0);
            int n = 0, i = 0;
            if (str == "") { MessageBox.Show("Žádný text!"); return data; }

            string[] split = str.Split(new Char[] { ' ', ':', '\n', '\r' });
            foreach (string s in split)
            {
                if (s == "") continue;      // if(Uri.IsHexDigit(myString[i]))

                int len = s.Length;
                if (len < 4)
                {
                    try
                    {
                        n = Convert.ToInt32(s, 16);
                    }
                    catch (FormatException) { continue; }

                    binar.Add((byte)n); i++;
                }
                else continue;
            }
            data = binar.ToArray();
            if (i == 0) { data = null; MessageBox.Show("Neplatný formát hex!"); }
            return data;
        }//


        private void click(object sender, EventArgs e)    // pro  ......Click += new System.EventHandler(this.click);
        {
            string stype = sender.GetType().ToString();
            switch (stype)
            {
                case "System.Windows.Forms.ToolStripMenuItem":
                    switch (((ToolStripMenuItem)sender).Name)   //nebo ...sender).Text, ale nevýhoda pro vícejazyčné verze
                    {
                        case "newToolStripMenuItem": status1 = "Ready"; ishex = 0; faze = 9;
                            text1 = ""; text2 = ""; status2 = ""; text4 = ""; datas = null; ishex = 0;
                            button7.UseVisualStyleBackColor = true; button8.UseVisualStyleBackColor = true;
                            button5.Enabled = button6.Enabled = false;
                            break;
                        case "aboutToolStripMenuItem": MessageBox.Show("About");
                            break;
                        case "contentsToolStripMenuItem": MessageBox.Show("Contens");
                            break;
                        case "undoToolStripMenuItem": if (textBox1.CanUndo == true)
                            {
                                textBox1.Undo();
                                textBox1.ClearUndo();
                            }

                            break;
                  //      case "customizeToolStripMenuItem": MessageBox.Show("Customize");
                  //          break;
                        default:
                            break;
                    }
                    break;

                case "System.Windows.Forms.Button":
                    switch (((Button)sender).Name)
                    {
                        case "button1": this.button3.Focus(); WriteC(); this.button1.Focus();  //vyslat
                            break;
                        case "button2": this.button3.Focus(); Application.DoEvents(); ReadC(0); this.button2.Focus(); //přijmout
                            break;
                        case "button3": cont = false; //stop
                            break;
                        case "button4": datas = null; textBox1.SelectAll(); textBox1.Cut(); TeLen();  //smazat                            
                            break;
                        case "button5": datas = BinStr(text1);  //OK
                            text1 = HexStr(datas); TeLen();
                            break;
                        case "button6": button5.Enabled = button6.Enabled = false; text1 = HexStr(datas); //Can                           
                            break;
                        case "button7": ishex++; if (ishex > 2) ishex = 0;
                            if (ishex==1) button7.BackColor = System.Drawing.Color.Yellow;  //hex
                            else if (ishex == 2) button7.BackColor = System.Drawing.Color.LightGreen;
                            else button7.UseVisualStyleBackColor = true;
                            text1 = Hex(ishex, textBox1); //textBox1.Refresh();
                            if (ishex==0)
                            {
                                button5.Enabled = button6.Enabled = false;
                            }
                            break;
                        case "button8": if (faze == 9) { faze = 0; button8.BackColor = System.Drawing.Color.Yellow; } //hlavička
                            else { faze = 9; button8.UseVisualStyleBackColor = true; } //hlavička 
                            break;
                        case "button9": if (!comexist) return;
                            if (hindex < 2)
                            {     //pri handsh RTS nelze nasravit RtsEnable                           
                                if (!rts) { rts = true; button9.BackColor = System.Drawing.Color.Yellow; }
                                else { rts = false; button9.UseVisualStyleBackColor = true; }
                                serp.RtsEnable = rts;
                            }

                            break;
                        case "button10": if (!comexist) return;
                            if (!dtr) { dtr = true; button10.BackColor = System.Drawing.Color.Yellow; }
                            else { dtr = false; button10.UseVisualStyleBackColor = true; }
                            serp.DtrEnable = dtr;
                            break;

                    }
                    break;

                case "System.Windows.Forms.CheckBox":

                    switch (((CheckBox)sender).Name)
                    {
                        case "checkBox4":
                            break;
                        case "checkBox2":
                            break;
                        case "checkBox5":
                            break;
                        case "checkBox7":
                            break;
                    }//switch  
                    break;
                default:
                    break;
            }//
        }//click

        private void richTextBox1_TextChanged(object sender, EventArgs e) { }


        private void OnMouseLeftButtonDown(object sender, EventArgs e) { Hex(ishex, textBox1); TeLen(); }

        private void label1_Click(object sender, EventArgs e)
        {

        }

       
       


    }//class Form1


    //----------------------------------------------------------------------------------------------------------------------

    /*
           private void button4_Click(object sender, EventArgs e)
           {
               text1 = "";

             Writ1 wrt = new Writ1();  //přenos z jiné třídy
               string str = "ahoj ";
              wrt.Pok(ref str);
               text1 = str;
               text1 += wrt.nam;
               text1 += wrt.Cls();

               wrt.text = "MNBVC";   
               text2 = wrt.text ; //přes get a set
               wrt.nam = "MENO"; //přes string 
               text2 += wrt.nam;
        
           }

           private void checkBox5_CheckedChanged(object sender, EventArgs e)
           {
               if (checkBox5.Checked == true) slist = 1; else slist = 0;
           } */

    /* 
       public partial class Writ1
       {
           public string strr = "";     //vlastnosti atd.
           public string nam = "jméno";
           public int numb = 1234;

           public void Pok(ref string pstr)    //metoda
           {
               this.text = "asdfghg";  //uloží se do strr

               pstr += "A " + numb.ToString();
               MessageBox.Show(pstr + this.text);
           }

           public string Cls()   //metoda
           {
               return "název";
           }

         public string text
           {
               set { strr = value; }
               get { return strr; }
           }
       }*/


}

// string str = textBox3.Text;
// adr = int.Parse(str, System.Globalization.NumberStyles.HexNumber);
// adr  = Convert.ToInt32(str, 16); 
//   text1 = Encoding.UTF8.GetString(datas, 0, ni);  //nebo tak  
//  Array.Resize(ref binar, bt); //zkrátí
/*   try
           {
               if (serp.IsOpen) serp.Close();            
               serp.Open();
           }
           catch (IOException ei)
           {
               MessageBox.Show(
                    "Sériový port " + comn + " neexistuje. \r\nZkus jiný.\r\n" + ei.GetType().Name);
           }*/
