// ----- LCD 4bit komunikace ver. 14.8.1 

#ifndef _LCD_HD44780_4bit_H__
#define _LCD_HD44780_4bit_H__


#define _XTAL_FREQ 16000000UL  //jen pri pouziti _delay_ms,
#define RS PORTAbits.RA1  //display text - command
#define EN PORTAbits.RA6  //display enable

#define CMD 0  //command
#define DT 1    //data


void LCD_Init();
//void CPU_Init();
void LCD_Chr(char, char );
// void LCD_Str(const char *str);
void LCD_Gxy(char radek, char sloupec);
void TxRxInit();
void Startup();
void RxDisp();
void TimeStr();
void Time();
void FreqCnt();
void Tick(char);
char Switch();
void Temp();
void Menu();
void Delay(char dms); //desitky ms
void Readeprom(char ei,  char *str);
void LCD_Strx(char cx);
void Sdelay(char dl); //1 je 32 us
void LedSet();
void Beep(char del);
void ShTime(char);
void Settm();
void SendMes(char *);
#ifdef DS
void DSWrite(char, char);
char DSRead(char);
void DSClRead();
void DSRAMRead();
void DSRAMWrite();
void DSClWrite();
#endif

#endif